#ifndef _MYSQL_SQL_INSERTS_LOADER_H_
#define _MYSQL_SQL_INSERTS_LOADER_H_


#include "mysql_sql_parser_base.h"
#include "grtsqlparser/sql_inserts_loader.h"


/** Implements DBMS specifics.
 * 
 * @ingroup sqlparser
 */
class MYSQL_SQL_PARSER_PUBLIC_FUNC Mysql_sql_inserts_loader : protected Mysql_sql_parser_base, public Sql_inserts_loader
{
public:
  Mysql_sql_inserts_loader(grt::GRT *grt);
  virtual ~Mysql_sql_inserts_loader() {}

  void load(const std::string &sql, const std::string &schema_name);

protected:
  // higher level
  int process_sql_statement(const MyxSQLTreeItem *tree);

  // parse tree core
  Parse_result process_insert_statement(const MyxSQLTreeItem *tree);

  // context
  std::string _schema_name;

  class Null_state_keeper : Mysql_sql_parser_base::Null_state_keeper
  {
  public:
    Null_state_keeper(Mysql_sql_inserts_loader *sql_parser)
      : Mysql_sql_parser_base::Null_state_keeper(sql_parser),
        _sql_parser(sql_parser)
    {}
    ~Null_state_keeper()
    {
      _sql_parser->_schema_name= std::string();
    }
  private:
    Mysql_sql_inserts_loader *_sql_parser;
  };
  friend class Null_state_keeper;
};


#endif // _MYSQL_SQL_INSERTS_LOADER_H_
